//+------------------------------------------------------------------+
//|                                          dex_Extremum_Trend_v2.1 |
//|                                               Grayman77 & akadex |
//+------------------------------------------------------------------+
#property copyright "Grayman77 & akadex | 2008"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 SkyBlue

//---- input parameters
extern int ExtDepth=3;
int PointTotal=2; //    
bool ShowComment=false;

int ShiftH[],ShiftL[]; //   Bars;
double PriceH[],PriceL[];

//---- buffers
double BufferHigh[];
double BufferLow[];
double PriceChannelHigh[];
double PriceChannelLow[];
double Signal[];
int bol;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
   
   SetIndexBuffer(0,Signal);
   SetIndexStyle(0,DRAW_HISTOGRAM,0,2);
   
   SetIndexBuffer(1,BufferHigh);
   SetIndexBuffer(2,BufferLow);
   SetIndexBuffer(3,PriceChannelHigh);
   SetIndexBuffer(4,PriceChannelLow);
   
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
   
   ArrayResize(ShiftH,PointTotal);
   ArrayResize(ShiftL,PointTotal);
   ArrayResize(PriceH,PointTotal);
   ArrayResize(PriceL,PointTotal);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  Comment("");
  ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  int    counted_bars=IndicatorCounted();
  int i,j,limit;
  int ShiftHigh,ShiftLow;
  int ShiftBufferHigh,ShiftBufferLow;
  double deltaHigh, deltaLow;
//----
  
  //  
  if(counted_bars<0) return(-1);
  
  //    
  if(counted_bars==0)  //     (  )
    {
    limit=Bars-ExtDepth;
    ShiftHigh=Highest(Symbol(),Period(),MODE_HIGH,ExtDepth,limit);
    ShiftLow=Lowest(Symbol(),Period(),MODE_LOW,ExtDepth,limit);
    //    
    BufferHigh[ShiftHigh]=High[ShiftHigh];
    BufferLow[ShiftLow]=Low[ShiftLow];
    PriceChannelHigh[limit]=High[ShiftHigh];
    PriceChannelLow[limit]=Low[ShiftLow];
    limit--;
    }
   else
    {
    counted_bars--;  //    
    limit = Bars - counted_bars;
    if(limit>Bars-ExtDepth-1) limit=Bars-ExtDepth-1;
    }
  
  for(i=limit; i>=0; i--) //   
    {
    ShiftHigh=Highest(Symbol(),Period(),MODE_HIGH,ExtDepth,i);
    ShiftLow=Lowest(Symbol(),Period(),MODE_LOW,ExtDepth,i);
    //   PriceChannel
    PriceChannelHigh[i]=High[ShiftHigh];
    PriceChannelLow[i]=Low[ShiftLow];
    /*
    //   BufferHigh[],BufferLow[]   
    BufferHigh[i]=0.;
    BufferLow[i]=0.;
    */
    //      BufferHigh[],BufferLow[]
    j=i+1;
    ShiftBufferHigh=0;
    ShiftBufferLow=0;
    while(ShiftBufferHigh==0 && ShiftBufferLow==0)
      {
      if(BufferHigh[j]!=0.) ShiftBufferHigh=j;
      if(BufferLow[j]!=0.) ShiftBufferLow=j;
      j++;
      }
    
    //   BufferHigh[],BufferLow[]:
    // -    
    if(PriceChannelLow[i]<PriceChannelLow[i+1] && PriceChannelHigh[i]<=PriceChannelHigh[i+1])
      {
      if(ShiftBufferHigh!=0)  //     - 
        {
        //   
        BufferLow[i]=PriceChannelLow[i];
        }
      if(ShiftBufferLow!=0)  //     - 
        {
        //    (    )
        if(BufferLow[ShiftBufferLow]>PriceChannelLow[i])
          {
          BufferLow[ShiftBufferLow]=0.;  //  
          BufferLow[i]=PriceChannelLow[i];  //  
          }
        }
      }
    // -    
    if(PriceChannelHigh[i]>PriceChannelHigh[i+1] && PriceChannelLow[i]>=PriceChannelLow[i+1])
      {
      if(ShiftBufferLow!=0)  //     - 
        {
        //   
        BufferHigh[i]=PriceChannelHigh[i];
        }
      if(ShiftBufferHigh!=0)  //     - 
        {
        //    (    )
        if(BufferHigh[ShiftBufferHigh]<PriceChannelHigh[i])
          {
          BufferHigh[ShiftBufferHigh]=0.;  //  
          BufferHigh[i]=PriceChannelHigh[i];  //  
          }
        }
      }
    // -      
    if(PriceChannelLow[i]<PriceChannelLow[i+1] && PriceChannelHigh[i]>PriceChannelHigh[i+1])
      {
      //      
      deltaHigh=PriceChannelHigh[i]-PriceChannelHigh[i+1];
      deltaLow=PriceChannelLow[i+1]-PriceChannelLow[i];
      //    
      if(deltaHigh>deltaLow)
        {
        if(ShiftBufferLow!=0)  //     - 
          {
          //   
          BufferHigh[i]=PriceChannelHigh[i];
          }
        if(ShiftBufferHigh!=0)  //     - 
          {
          //    (    )
          if(BufferHigh[ShiftBufferHigh]<PriceChannelHigh[i])
            {
            BufferHigh[ShiftBufferHigh]=0.;  //  
            BufferHigh[i]=PriceChannelHigh[i];  //  
            }
          } 
        }
       else   //     ( !!!)
        {
        if(ShiftBufferHigh!=0)  //     - 
          {
          //   
          BufferLow[i]=PriceChannelLow[i];
          }
        if(ShiftBufferLow!=0)  //     - 
          {
          //    (    )
          if(BufferLow[ShiftBufferLow]>PriceChannelLow[i])
            {
            BufferLow[ShiftBufferLow]=0.;  //  
            BufferLow[i]=PriceChannelLow[i];  //  
            }
          }
        }
      
      }
    
    // -----  
    
    //     BufferHigh[],BufferLow[]
    FindCrossH(i);
    FindCrossL(i);
    bol=0;
    
    //----       

      //-Buy
      if (High[i]>PriceH[0]) bol=1; 

      //-Sell       
      if (Low[i]<PriceL[0]) bol=-1; 
       
      if (bol==0) Signal[i]=Signal[i+1]; else Signal[i]=bol; 
      
      //----         

    if(!IsTesting() && ShowComment)
      {
      Comment ("\n High "+PriceH[0]+"    "+ShiftH[0]+
               "\n Low "+PriceL[0]+"    "+ShiftL[0]+
               "\n\n High "+PriceH[1]+"    "+ShiftH[1]+
               "\n Low "+PriceL[1]+"    "+ShiftL[1]);
      } 
    
    
    }
  
  
   
//----
  return(0);
  }
//+------------------------------------------------------------------+

//+---------------------------------------------------------------------+
//|     PointTotal       |
//|   BufferHigh[]  PointTotal    BufferLow[].|
//|       .  . :   |
//|   -  ShiftH[],ShiftL[];                                     |
//|   -  PriceH[] (High[]  h[]), PriceL[] (Low[]  l[])        |
//+---------------------------------------------------------------------+
void FindCrossH(int _Shift)
  {
   int i,j;

   //  
   for(i=0;i<PointTotal;i++)
     {
      ShiftH[i]=0;
      PriceH[i]=0.;
     }

   //   
   i=_Shift+1; // 
   j=-1; //  
   while(j<PointTotal) //      
     {
      while(BufferHigh[i]==0. && i<Bars-2) i++;
      j++; //  j- 
      ShiftH[j]=i;
      PriceH[j]=High[i];
      i++; //    1
     }
   return;
  }

//+------------------------------------------------------------------+

void FindCrossL(int _Shift)
  {
   int i,j;

   //  
   for(i=0;i<PointTotal;i++)
     {
      ShiftL[i]=0;
      PriceL[i]=0.;
     }

   //   
   i=_Shift+1; // 
   j=-1; //  
   while(j<PointTotal) //      
     {
      while(BufferLow[i]==0. && i<Bars-2) i++;
      j++; //  j- 
      ShiftL[j]=i;
      PriceL[j]=Low[i];
      i++; //    1
     }
   return;
  }

